import fasttext

language_codes = {
    '__label__af': 'Afrikaans',
    '__label__als': 'Alemannic',
    '__label__am': 'Amharic',
    '__label__an': 'Aragonese',
    '__label__ar': 'Arabic',
    '__label__arz': 'Egyptian Arabic',
    '__label__as': 'Assamese',
    '__label__ast': 'Asturian',
    '__label__av': 'Avaric',
    '__label__az': 'Azerbaijani',
    '__label__azb': 'South Azerbaijani',
    '__label__ba': 'Bashkir',
    '__label__bar': 'Bavarian',
    '__label__bcl': 'Central Bikol',
    '__label__be': 'Belarusian',
    '__label__bg': 'Bulgarian',
    '__label__bh': 'Bihari',
    '__label__bn': 'Bengali',
    '__label__bo': 'Tibetan',
    '__label__bpy': 'Bishnupriya Manipuri',
    '__label__br': 'Breton',
    '__label__bs': 'Bosnian',
    '__label__bxr': 'Russia Buriat',
    '__label__ca': 'Catalan',
    '__label__cbk': 'Chavacano',
    '__label__ce': 'Chechen',
    '__label__ceb': 'Cebuano',
    '__label__ckb': 'Sorani Kurdish',
    '__label__co': 'Corsican',
    '__label__cs': 'Czech',
    '__label__cv': 'Chuvash',
    '__label__cy': 'Welsh',
    '__label__da': 'Danish',
    '__label__de': 'German',
    '__label__diq': 'Zazaki',
    '__label__dsb': 'Lower Sorbian',
    '__label__dty': 'Doteli',
    '__label__dv': 'Divehi',
    '__label__el': 'Greek',
    '__label__eml': 'Emilian-Romagnol',
    '__label__en': 'English',
    '__label__eng': 'English',
    '__label__eo': 'Esperanto',
    '__label__es': 'Spanish',
    '__label__et': 'Estonian',
    '__label__eu': 'Basque',
    '__label__fa': 'Persian',
    '__label__fi': 'Finnish',
    '__label__fr': 'French',
    '__label__frr': 'North Frisian',
    '__label__fy': 'Western Frisian',
    '__label__ga': 'Irish',
    '__label__gd': 'Scottish Gaelic',
    '__label__gl': 'Galician',
    '__label__gn': 'Guarani',
    '__label__gom': 'Goan Konkani',
    '__label__gu': 'Gujarati',
    '__label__gv': 'Manx',
    '__label__he': 'Hebrew',
    '__label__hi': 'Hindi',
    '__label__hif': 'Fiji Hindi',
    '__label__hr': 'Croatian',
    '__label__hsb': 'Upper Sorbian',
    '__label__ht': 'Haitian Creole',
    '__label__hu': 'Hungarian',
    '__label__hy': 'Armenian',
    '__label__ia': 'Interlingua',
    '__label__id': 'Indonesian',
    '__label__ie': 'Interlingue',
    '__label__ilo': 'Iloko',
    '__label__io': 'Ido',
    '__label__is': 'Icelandic',
    '__label__it': 'Italian',
    '__label__ja': 'Japanese',
    '__label__jbo': 'Lojban',
    '__label__jv': 'Javanese',
    '__label__ka': 'Georgian',
    '__label__kk': 'Kazakh',
    '__label__km': 'Khmer',
    '__label__kn': 'Kannada',
    '__label__ko': 'Korean',
    '__label__krc': 'Karachay-Balkar',
    '__label__ku': 'Kurdish',
    '__label__kv': 'Komi',
    '__label__kw': 'Cornish',
    '__label__ky': 'Kyrgyz',
    '__label__la': 'Latin',
    '__label__lb': 'Luxembourgish',
    '__label__lez': 'Lezghian',
    '__label__li': 'Limburgish',
    '__label__lmo': 'Lombard',
    '__label__lo': 'Lao',
    '__label__lrc': 'Northern Luri',
    '__label__lt': 'Lithuanian',
    '__label__lv': 'Latvian',
    '__label__mai': 'Maithili',
    '__label__mg': 'Malagasy',
    '__label__mhr': 'Eastern Mari',
    '__label__min': 'Minangkabau',
    '__label__mk': 'Macedonian',
    '__label__ml': 'Malayalam',
    '__label__mn': 'Mongolian',
    '__label__mr': 'Marathi',
    '__label__mrj': 'Western Mari',
    '__label__ms': 'Malay',
    '__label__mt': 'Maltese',
    '__label__mwl': 'Mirandese',
    '__label__my': 'Burmese',
    '__label__myv': 'Erzya',
    '__label__mzn': 'Mazanderani',
    '__label__nah': 'Nahuatl',
    '__label__nap': 'Neapolitan',
    '__label__nds': 'Low German',
    '__label__ne': 'Nepali',
    '__label__new': 'Newari',
    '__label__nl': 'Dutch',
    '__label__nn': 'Norwegian Nynorsk',
    '__label__no': 'Norwegian',
    '__label__oc': 'Occitan',
    '__label__or': 'Odia',
    '__label__os': 'Ossetian',
    '__label__pa': 'Punjabi',
    '__label__pam': 'Pampanga',
    '__label__pfl': 'Palatine German',
    '__label__pl': 'Polish',
    '__label__pms': 'Piedmontese',
    '__label__pnb': 'Western Punjabi',
    '__label__ps': 'Pashto',
    '__label__pt': 'Portuguese',
    '__label__qu': 'Quechua',
    '__label__rm': 'Romansh',
    '__label__ro': 'Romanian',
    '__label__ru': 'Russian',
    '__label__rue': 'Rusyn',
    '__label__sa': 'Sanskrit',
    '__label__sah': 'Sakha',
    '__label__sc': 'Sardinian',
    '__label__scn': 'Sicilian',
    '__label__sco': 'Scots',
    '__label__sd': 'Sindhi',
    '__label__sh': 'Serbo-Croatian',
    '__label__si': 'Sinhala',
    '__label__sk': 'Slovak',
    '__label__sl': 'Slovenian',
    '__label__so': 'Somali',
    '__label__sq': 'Albanian',
    '__label__sr': 'Serbian',
    '__label__su': 'Sundanese',
    '__label__sv': 'Swedish',
    '__label__sw': 'Swahili',
    '__label__ta': 'Tamil',
    '__label__te': 'Telugu',
    '__label__tg': 'Tajik',
    '__label__th': 'Thai',
    '__label__tk': 'Turkmen',
    '__label__tl': 'Tagalog',
    '__label__tr': 'Turkish',
    '__label__tt': 'Tatar',
    '__label__tyv': 'Tuvan',
    '__label__ug': 'Uighur',
    '__label__uk': 'Ukrainian',
    '__label__ur': 'Urdu',
    '__label__uz': 'Uzbek',
    '__label__vec': 'Venetian',
    '__label__vep': 'Veps',
    '__label__vi': 'Vietnamese',
    '__label__vls': 'West Flemish',
    '__label__vo': 'Volapük',
    '__label__wa': 'Walloon',
    '__label__war': 'Waray',
    '__label__wuu': 'Wu Chinese',
    '__label__xal': 'Kalmyk',
    '__label__xmf': 'Mingrelian',
    '__label__yi': 'Yiddish',
    '__label__yo': 'Yoruba',
    '__label__yue': 'Cantonese',
    '__label__zh': 'Chinese',
}


class LangPredict:
    def predict_language(self, text: str, model_path:str):
        model = fasttext.load_model(model_path)
        prediction = model.predict(text)
        label = language_codes.get(prediction[0][0], 'Unknown language')
        probability = prediction[1][0]
        return label, probability

    def train(self, train_data_path: str, output_path:str):
        model = fasttext.train_supervised(train_data_path, label="__label__")
        model.save_model(output_path + '.bin')

    def preprocess_data(self, input_file: str, output_file: str, language_label: str = "__label__pl"):
        with open(input_file, 'r', encoding='utf-8') as input_file:
            data = input_file.read()

        data = data.replace('\n', ' ')
        sentences = [sentence.strip() for sentence in data.split('.') if sentence.strip()]
        labeled_sentences = [f"{language_label} {sentence}" for sentence in sentences]
        with open(output_file, 'w', encoding='utf-8') as output_file:
            output_file.write('\n'.join(labeled_sentences))

    def merge_files(self, file1_path, file2_path, output_path):
        with open(file1_path, 'r', encoding='utf-8') as file1:
            data1 = file1.read()

        with open(file2_path, 'r', encoding='utf-8') as file2:
            data2 = file2.read()

        merged_data = data1 + '\n' + data2

        with open(output_path, 'w', encoding='utf-8') as output_file:
            output_file.write(merged_data)
